unit Unit1;

interface

uses
  Windows, SysUtils,
  Graphics, Forms, Classes,
  StdCtrls, Controls, SegaGradients,
  Menus, Dialogs, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Choosetype1: TMenuItem;
    opLeftDiagonal1: TMenuItem;
    opRightDiagonal1: TMenuItem;
    Envelope1: TMenuItem;
    Circles1: TMenuItem;
    LeftRightPies1: TMenuItem;
    opBottomPies1: TMenuItem;
    Horizontal1: TMenuItem;
    Vertical1: TMenuItem;
    Diamond: TMenuItem;
    HorizontalWaves: TMenuItem;
    VerticalWaves: TMenuItem;
    more: TMenuItem;
    RoundStar: TMenuItem;
    Star: TMenuItem;
    TopLeftFan: TMenuItem;
    andMORE: TMenuItem;
    TopRightFan: TMenuItem;
    BottomLeftFan: TMenuItem;
    BottomRightFan: TMenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure TopLeftDiagonalClick(Sender: TObject);
    procedure TopRightDiagonalClick(Sender: TObject);
    procedure EnvelopeClick(Sender: TObject);
    procedure CirclesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure LeftToRightHalfCirclesClick(Sender: TObject);
    procedure TopToBottomHalfCirclesClick(Sender: TObject);
    procedure HorizontalClick(Sender: TObject);
    procedure VerticalClick(Sender: TObject);
    procedure DiamondClick(Sender: TObject);
    procedure HorizontalWavesClick(Sender: TObject);
    procedure VerticalWavesClick(Sender: TObject);
    procedure RoundStarClick(Sender: TObject);
    procedure StarClick(Sender: TObject);
    procedure TopLeftFanClick(Sender: TObject);
    procedure TopRightFanClick(Sender: TObject);
    procedure BottomLeftFanClick(Sender: TObject);
    procedure BottomRightFanClick(Sender: TObject);
//    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
//      Rect: TRect; State: TOwnerDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  BMP:TBitmap;
  Draw:Boolean=True;

implementation

{$R *.dfm}

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Draw:=False;
 BMP.Free;
end;

procedure TForm1.TopLeftDiagonalClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr,DiagonalArrayWidth(BMP.Canvas.ClipRect)+1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],ColArr,
                  DiagonalArrayWidth(BMP.Canvas.ClipRect));
TopLeftDiagGradient(BMP.Canvas,
                     BMP.Canvas.ClipRect,
                     ColArr);
Canvas.StretchDraw(Clientrect,BMP);
Finalize(ColArr);
end;

procedure TForm1.TopRightDiagonalClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr,DiagonalArrayWidth(BMP.Canvas.ClipRect)+1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],ColArr,
                  DiagonalArrayWidth(BMP.Canvas.ClipRect));
TopRightDiagGradient(BMP.Canvas,
                     BMP.Canvas.ClipRect,
                     ColArr);
Canvas.StretchDraw(Clientrect,BMP);
Finalize(ColArr);
end;

procedure TForm1.EnvelopeClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr,EnvelopeArrayWidth(BMP.Canvas.ClipRect)+1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],
                  ColArr,
                  EnvelopeArrayWidth(BMP.Canvas.ClipRect));
EnvelopeGradient(BMP.Canvas,BMP.Canvas.ClipRect,ColArr);
Canvas.StretchDraw(Clientrect,BMP);
Finalize(ColArr);
end;

procedure TForm1.CirclesClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr,CirclesArrayWidth(BMP.Canvas.ClipRect)+1);

ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],
                  ColArr,
                  CirclesArrayWidth(BMP.Canvas.ClipRect));

CirclesGradient(BMP.Canvas,
                Bmp.Canvas.ClipRect,
                ColArr);
Canvas.StretchDraw(ClientRect,BMP);
Finalize(ColArr);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
BMP:=TBitmap.Create;
BMP.Width:=Screen.Width;
BMP.Height:=Screen.Height;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
if Draw then
 Canvas.StretchDraw(ClientRect,BMP);
end;

procedure TForm1.LeftToRightHalfCirclesClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr,LeftRightPiesArrayWidth(BMP.Canvas.ClipRect) +1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],ColArr,
                  LeftRightPiesArrayWidth(BMP.Canvas.ClipRect));
LeftRightPiesGradient(BMP.Canvas,
                      BMP.Canvas.ClipRect,
                      ColArr);
Canvas.StretchDraw(ClientRect,BMP);
Finalize(ColArr);
end;

procedure TForm1.TopToBottomHalfCirclesClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, TopBottomPiesArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clBlack, clRed, $004080FF,
                  clYellow, clGreen, clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen, clYellow,
                  $004080FF, clRed, clBlack], ColArr,
                  TopBottomPiesArrayWidth(BMP.Canvas.ClipRect));
TopBottomPiesGradient(BMP.Canvas,
                      BMP.Canvas.ClipRect,
                      ColArr);
Canvas.StretchDraw(ClientRect,BMP);
Finalize(ColArr);
end;

procedure TForm1.HorizontalClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, HorizontalArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clBlack],
                  ColArr,
                  HorizontalArrayWidth(BMP.Canvas.ClipRect));
HorizontalGradient(BMP.Canvas,
                   BMP.Canvas.ClipRect,
                   ColArr);
Canvas.StretchDraw(Clientrect,BMP);
Finalize(ColArr);
end;

procedure TForm1.VerticalClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, VerticalArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],
                  ColArr,
                  VerticalArrayWidth(BMP.Canvas.ClipRect));
VerticalGradient(BMP.Canvas,
                 BMP.Canvas.ClipRect,
                 ColArr);
Canvas.StretchDraw(Clientrect,BMP);
Finalize(ColArr);
end;

procedure TForm1.DiamondClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, DiamondArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],
                  ColArr,
                  DiamondArrayWidth(BMP.Canvas.ClipRect));
DiamondGradient(BMP.Canvas,
                BMP.Canvas.ClipRect,
                ColArr);
Canvas.StretchDraw(Clientrect,BMP);
Finalize(ColArr);
end;

procedure TForm1.HorizontalWavesClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, HorWaveArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],
                  ColArr,
                  HorWaveArrayWidth(BMP.Canvas.ClipRect));

HorWaveGradient(BMP.Canvas,
                BMP.Canvas.ClipRect,
                ColArr);

Canvas.StretchDraw(Clientrect,BMP);
end;

procedure TForm1.VerticalWavesClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, VertWaveArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],
                  ColArr,
                  VertWaveArrayWidth(BMP.Canvas.ClipRect));

VertWaveGradient(BMP.Canvas,
                BMP.Canvas.ClipRect,
                ColArr);

Canvas.StretchDraw(Clientrect,BMP);
end;


procedure TForm1.RoundStarClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, RoundStarArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clGreen,clBlack,
                  clWhite,
                  clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clGreen],
                  ColArr,
                  RoundStarArrayWidth(BMP.Canvas.ClipRect));
RoundStarGradient(BMP.Canvas,
                  BMP.Canvas.ClipRect,
                  ColArr);

Canvas.StretchDraw(Clientrect,BMP);
Finalize(ColArr);
end;

procedure TForm1.StarClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, StarArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clBlack,clRed,$004080FF,
                  clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clBlack],
                  ColArr,
                  StarArrayWidth(BMP.Canvas.ClipRect));

StarGradient(BMP.Canvas,
             BMP.Canvas.ClipRect,
             ColArr);

Canvas.StretchDraw(ClientRect,BMP);
Finalize(ColArr);
end;


procedure TForm1.TopLeftFanClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr,TopLeftFanArrayWidth(BMP.Canvas.ClipRect)+1);
ComplexFillArray([clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clGreen,clBlack,
                  clWhite,clRed,clRed,$004080FF,
                  clYellow,clGreen,clPurple,
                  clNavy,
                  clBlue, clGreen,clYellow,clGreen],
                  ColArr,
                  TopLeftFanArrayWidth(BMP.Canvas.ClipRect));

TopLeftFanGradient(BMP.Canvas,
                   BMP.Canvas.ClipRect,
                   ColArr);
Canvas.StretchDraw(ClientRect,BMP);
Finalize(ColArr);
end;

procedure TForm1.TopRightFanClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, TopRightFanArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clGreen,clBlack,
                  clWhite,clRed,clRed,$004080FF,
                  clYellow,clGreen,clPurple,
                  clNavy,
                  clBlue, clGreen,clYellow,clGreen],
                  ColArr,
                  TopRightFanArrayWidth(BMP.Canvas.ClipRect));

TopRightFanGradient(BMP.Canvas,
                    BMP.Canvas.ClipRect,
                    ColArr);
Canvas.StretchDraw(ClientRect,BMP);
Finalize(ColArr);
end;

procedure TForm1.BottomLeftFanClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, BottomLeftFanArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clGreen,clBlack,
                  clWhite,clRed,clRed,$004080FF,
                  clYellow,clGreen,clPurple,
                  clNavy,
                  clBlue, clGreen,clYellow,clGreen],
                  ColArr,
                  BottomLeftFanArrayWidth(BMP.Canvas.ClipRect));

BottomLeftFanGradient(BMP.Canvas,
                      BMP.Canvas.ClipRect,
                      ColArr);
Canvas.StretchDraw(ClientRect,BMP);
Finalize(ColArr);
end;

procedure TForm1.BottomRightFanClick(Sender: TObject);
var ColArr:TColorArray;
begin
SetLength(ColArr, BottomRightFanArrayWidth(BMP.Canvas.ClipRect) + 1);
ComplexFillArray([clYellow,clGreen,clBlue,
                  clNavy, clPurple, clNavy,
                  clBlue, clGreen,clYellow,
                  $004080FF, clRed,clWhite,clBlack,
                  clWhite,clRed,clRed,$004080FF,
                  clYellow,clGreen,clPurple,clBlue,
                  clNavy,
                  clBlue, clGreen,clYellow],
                  ColArr,
                  BottomRightFanArrayWidth(BMP.Canvas.ClipRect));

BottomRightFanGradient(BMP.Canvas,
                       BMP.Canvas.ClipRect,
                       ColArr);
Canvas.StretchDraw(ClientRect,BMP);
Finalize(ColArr);
end;

end.
